/*-------------------------------------------------------------------------------------------*\
|                                                                                             |
|    Copyright (C) 1999 by Punk Productions Electronic Entertainment. All Rights Reserved.    | 
|                                                                                             |
|    Purpose.....: Shows how to load JPEG files into a DDsurface                              |
|    Programmer..: Nikolaus Brennig, 19, (Nikolaus.Brennig@nol.at)                            |
|	 Contact.....: virtalnik@nol.at || ICQ: 20345533										  |
|	 Internet....: http://cust.nol.at/ppee													  |
|    Help........: Joine the PPEE-GamesDev MailingList			                              |
|    Day created.: February 17th, 1999                                                        |
|    Update......: March, 30th, 1999                                                          |
|				   Can't remember anymore what i've changed :)								  |
|				   October, 3rd, 1999:														  |
|				   Completely rewritten, Faster Loading/Saving, C++ Interface                 |
|				   now the original JPEGLib 6.2 is used, also Support for                     |
|				   loading PPM/PGM files. Requires at least DirectX7                          |
|                                                                                             |
\*-------------------------------------------------------------------------------------------*/

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <windowsx.h>
#include <stdio.h>

#define WIDTHBYTES(bits)    (((bits) + 31) / 32 << 2)

class CJPEG
{
	public:
		/*
			Con/Destruction:
			~~~~~~~~~~~~~~~~
		*/
			CJPEG();
			~CJPEG();


		/*
			Loading:
			~~~~~~~~
		*/
			static BYTE *LoadJPEG( 
				LPSTR fileName, 
				UINT *width, 
				UINT *height, 
				INT *Bits  
			); 

			static BYTE *LoadPPM(
				LPSTR fileName, 
				UINT *width, 
				UINT *height, 
				INT *Bits
			);

			static BYTE *MakeDWORDAligned( 
				BYTE *dataBuf, 
				UINT widthPix, 
				UINT height, 
				UINT *uiOutWidthBytes 
			); 

			static BOOL FlipVertically( 
				BYTE *inbuf, 
				UINT widthbytes, 
				UINT height 
			);

			static BOOL BGRFromRGB( 
				BYTE *buf, 
				UINT widthPix, 
				UINT height 
			);

		/*
			Saving:
			~~~~~~~
		*/
			static BOOL SaveJPEG( 
				LPSTR fileName, 
				BYTE *dataBuf, 
				UINT width, 
				UINT height, 
				BOOL color, 
				int quality 
			);

			static BYTE *MakeRGBAligned( 
				BYTE *inBuf, 
				UINT widthPix, 
				UINT widthBytes, 
				UINT height 
			);

			static BOOL RGBFromBGR( 
				BYTE *buf, 
				UINT widthPix, 
				UINT height
			);

	private:
			static VOID WriteRGBScanline( 
				BYTE *jpegline, 
				int widthPix, 
				BYTE *outBuf, 
				int row 
			);

			static VOID WriteGRAYScanline( 
				BYTE *jpegline, 
				int widthPix, 
				BYTE *outBuf, 
				int row 
			);
};


